/ dimensions
m			*a*
kg			*b*
sec			*c*
coul			*d*
candela			*e*
dollar			*f*
radian			*g*
bit			*h*
erlang			*i*
degC			*j*

/ constants

fuzz			1
pi			3.14159265358979323846
c			2.997925+8 m/sec fuzz
g			9.80665 m/sec2
au			1.49597871+11 m fuzz
mole			6.022169+23 fuzz
e			1.6021917-19 coul fuzz
energy			c2
force			g
mercury			1.33322+5 kg/m2-sec2
hg			mercury

/ dimensionless

degree			1|180 pi-radian
circle			2 pi-radian
turn			2 pi-radian
grade			.9 degree
arcdeg			1 degree
arcmin			1|60 arcdeg
ccs			1|36 erlang
arcsec			1|60 arcmin

steradian		radian2
sphere			4 pi-steradian
sr			steradian

/ Time

second			sec
s			sec
minute			60 sec
min			minute
hour			60 min
hr			hour
day			24 hr
da			day
week			7 day
year			365.24219879 day fuzz
yr			year
month			1|12 year
ms			millisec
us			microsec

/ Mass

gram			millikg
gm			gram
mg			milligram
metricton		kilokg

/ Avoirdupois

lb			.45359237 kg
lbf			lb g
ounce			1|16 lb
oz			ounce
dram			1|16 oz
dr			dram
grain			1|7000 lb
gr			grain
shortton		2000 lb
ton			shortton
longton			2240 lb

/ Apothecary

scruple			20 grain
apdram			60 grain
apounce			480 grain
appound			5760 grain

/ Length

meter			m
cm			centimeter
mm			millimeter
km			kilometer
nm			nanometer
micron			micrometer
angstrom		decinanometer

inch			2.54 cm
in			inch
foot			12 in
feet			foot
ft			foot
yard			3 ft
yd			yard
rod			5.5 yd
rd			rod
mile			5280 ft
mi			mile

british			1200|3937 m/ft
nmile			1852m

acre			4840 yd2

cc			cm3
liter			kilocc
ml			milliliter

/ US Liquid

gallon			231 in3
imperial		1.20095
gal			gallon
quart			1|4 gal
qt			quart
pint			1|2 qt
pt			pint

floz			1|16 pt
fldr			1|8 floz

/ US Dry

dry			268.8025 in3/gallon fuzz
peck			8 dry-quart
pk			peck
bushel			4 peck
bu			bushel

/ British

brgallon		277.420 in3 fuzz
brquart			1|4 brgallon
brpint			1|2 brquart
brfloz			1|20 brpint
brpeck			554.84 in3 fuzz
brbushel		4 brpeck

/ Energy Work

newton			kg-m/sec2
nt			newton
joule			nt-m
cal			4.1868 joule

/ Electrical

coulomb			coul
ampere			coul/sec
amp			ampere
watt			joule/sec
volt			watt/amp
ohm			volt/amp
mho			/ohm
farad			coul/volt
henry			sec2/farad
weber			volt-sec

/ Light

cd			candela
lumen			cd sr
lux			cd sr/m2

/ Money
/ epoch May 18, 1977 wall st j

$			dollar
argentinapeso		.0030 $
australiadollar		1.1065 $
austriaschilling	.0597 $
belgiumfranc		.0277 $
brazilcruzeiro		.0733 $
britainpound		1.7187 $
canadadollar		.9550 $
colombiapeso		.0276 $
denmarkkrone		.1663 $
equadorsucre		.0365 $
finlandmarkka		.2456 $
francefranc		.2021 $
greecedrachma		.0272 $
hongkongdollar		.2134 $
indiarupee		.1145 $
indonesiarupiah		.00259 $
iranrial		.0143 $
iraqdinar		3.41 $
israelpound		.1105 $
italylira		.001130 $
japanyen		.003607 $
lebanonpound		.3285 $
malaysiadollar		.4032 $
mexicopeso		.0445 $
netherlandsguilder	.4080 $
newzealanddollar		.9665 $
norwaykrone		.1899 $
pakistanrupee		.1025 $
perusol			.0129 $
philippinespeso	.1345 $
portugalescudo		.0259 $
saudiarabiariyal		.2860 $
singaporedollar		.4061 $
southafricarand		1.1522 $
southkoreawon		.0021 $
spainpeseta		.01451 $
swedenkrona		.2296 $
switzerlandfranc	.3970 $
thailandbhat		.050 $
uruguaypeso		.2330 $
venezuelabolivar	.2335 $
germanymark		.4243 $

mark			germanymark
bolivar			venezuelabolivar
peseta			spainpeseta
rand			southafricarand
escudo			portugalescudo
sol			perusol
guilder			netherlandsguilder
peso			mexicopeso
yen			japanyen
lira			italylira
dinar			iraqdinar
rial			iranrial
rupee			indiarupee
drachma			greecedrachma
franc			francefranc
markka			finlandmarkka
sucre			equadorsucre
pound			britainpound
poundsterling		britainpound
cruzeiro		brazilcruzeiro

/ PDP-11

baud			bit/sec
byte			8 bit
word			2 byte
block			512 byte
K			1024 word
tc			578 block
rktrack			12 block
rkcylinder		2 rktrack
rk			203 rkcylinder
rptrack			10 block
rpcylinder		20 rptracks
rp			406 rpcylinder
rftrack			8 block
rfshoe			8 rftrack
rfdisk			16 rfshoe
rf			2 rfdisk

/ Trivia

%			1|100
admiraltyknot		6080 ft/hr
apostilb		cd/pi-m2
are			1+2 m2
arpentcan		27.52 mi
arpentlin		191.835 ft
astronomicalunit	au
atmosphere		1.01325+5 nt/m2
atm			atmosphere
atomicmassunit		1.66044-27 kg fuzz
amu			atomicmassunit
bag			94 lb
bakersdozen		13
bar			1+5 nt/m2
barie			1-1 nt/m2
barleycorn		1|3 in
barn			1-28 m2
barrel			42 gal
barye			1-1 nt/m2
bev			1+9 e-volt
biot			10 amp
blondel			cd/pi-m2
boardfoot		144 in3
bolt			40 yd
bottommeasure		1|40 in
britishthermalunit	1.05506+3 joule fuzz
btu			britishthermalunit
refrigeration		12000 btu/ton-hour
buck			dollar
cable			720 ft
caliber			1-2 in
calorie			cal
carat			205 mg
cent			centidollar
cental			100 lb
centesimalminute	1-2 grade
centesimalsecond	1-4 grade
century			100 year
cfs			ft3/sec
chain			66 ft
circularinch		1|4 pi-in2
circularmil		1-6|4 pi-in2
clusec			1-8 mm-hg m3/s
coomb			4 bu
cord			128 ft3
cordfoot		cord
crith			9.06-2 gm
cubit			18 in
cup			1|2 pt
curie			3.7+10 /sec
dalton			amu
decade			10 yr
dioptre			/m
displacementton		35 ft3
doppelzentner		100 kg
dozen			12
drop			.03 cm3
dyne			cm-gm/sec2
electronvolt		e-volt
ell			45 in
engineerschain		100 ft
engineerslink		100|100 ft
equivalentfootcandle	lumen/pi-ft2
equivalentlux	lumen/pi-m2
equivalentphot		cd/pi-cm2
erg			cm2-gm/sec2
ev			e-volt
faraday			9.652+4 coul
fathom			6 ft
fermi			1-15 m
fifth			4|5 qt
fin			5 dollar
finger			7|8 in
firkin			9 gal
footcandle		lumen/ft2
footlambert		cd/pi-ft2
fortnight		14 da
franklin		3.33564-10 coul
frigorie		kilocal
furlong			220 yd
galileo			1-2 m/sec2
gamma			1-9 weber/m2
gauss			1-4 weber/m2
geodeticfoot		british-ft
geographicalmile	1852 m
gilbert			7.95775-1 amp
gill			1|4 pt
gross			144
gunterschain		22 yd
hand			4 in
hectare			1+4 m2
hefnercandle		.92 cd
hertz			/sec
hogshead		2 barrel
hd			hogshead
homestead		1|4 mi2
horsepower		550 ft-lb-g/sec
hp			horsepower
hyl			gm force sec2/m
hz			/sec
imaginarycubicfoot	1.4 ft3
jeroboam		4|5 gal
karat			1|24
kcal			kilocal
kcalorie		kilocal
kelvin			degC
kev			1+3 e-volt
key			kg
khz			1+3 /sec
kilderkin		18 gal
knot			nmile/hr
lambert			cd/pi-cm2
langley			cal/cm2
last			80 bu
league			3 mi
lightyear		c-yr
line			1|12 in
link			66|100 ft
longhundredweight	112 lb
longquarter		28 lb
lusec			1-6 mm-hg m3/s
mach			331.46 m/sec
magnum			2 qt
marineleague		3 nmile
maxwell			1-8 weber
metriccarat		200 mg
mev			1+6 e-volt
mgd			megagal/day
mh			millihenry
mhz			1+6 /sec
mil			1-2 in
millenium		1000 year
minersinch		1.5 ft3/min
minim			1|60 fldr
mo			month
mpg			mile/gal
mph			mile/hr
nail			1|16 yd
nauticalmile		nmile
nit			cd/m2
noggin			1|8 qt
nox			1-3 lux
ns			nanosec
oersted			2.5+2 pi-amp/m
oe			oersted
pace			36 in
palm			3 in
parasang		3.5 mi
parsec			au-radian/arcsec
pascal			nt/m2
pc			parsec
pennyweight		1|20 oz
percent			%
perch			rd
pf			picofarad
phot			lumen/cm2
pica			1|6 in
pieze			1+3 nt/m2
pipe			4 barrel
point			1|72 in
poise			gm/cm-sec
pole			rd
poundal			ft-lb/sec2
pdl			poundal
proof			1|200
psi			lb-g/in2
quarter			9 in
quartersection		1|4 mi2
quintal			100 kg
quire			25
rad			100 erg/gm
rankine			1.8 kelvin
ream			500
registerton		100 ft3
rehoboam		156 floz
rhe			10 m2/nt-sec
rontgen			2.58-4 curie/kg
rood			1.21+3 yd2
rope			20 ft
rutherford		1+6 /sec
rydberg			1.36054+1 ev
sabin			1 ft2
sack			3 bu
seam			8 bu
section			mi2
shippington		40 ft3
shorthundredweight	100 lb
shortquarter		25 lb
siemens			/ohm
sigma			microsec
skein			120 yd
skot			1-3 apostilb
slug			lb-g-sec2/ft
span			9 in
spat			4 pi sr
spindle			14400 yd
square			100 ft2
stere			m3
sthene			1+3 nt
stilb			cd/cm2
stoke			1-4 m2/sec
stone			14 lb
strike			2 bu
surveyfoot		british-ft
surveyorschain		66 ft
surveyorslink		66|100 ft
tablespoon		4 fldr
teaspoon		4|3 fldr
tesla			weber/m2
therm			1+5 btu
thermie			1+6 cal
timberfoot		ft3
tnt			4.6+6 m2/sec2
tonne			1+6 gm
torr			mm hg
township		36 mi2
tun			8 barrel
water			.22491|2.54 kg/m2-sec2
wey			40 bu
weymass			252 lb
Xunit			1.00202-13m
k			1.38047-16 erg/degC
