/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*
 * $Header: errors.h 1.1 86/05/20 $
 */

/*
 * $Log:	errors.h,v $
 */


/* CORE Error Codes and Classes */

#define	ERRDOS		0x01		/* error generated by OS */
#define	ERRSRV		0x02		/* error generated by server */
#define	ERRHRD		0x03		/* error generated by hardware */
#define	ERRCMD		0xFF		/* command not in "SMB" format */

/* SUCCESS codes */

#define	SUCCESS		0x00		/* successful request */
#define	BUFFERED	0x54		/* message has been buffered */
#define	LOGGED		0x55		/* message has been logged */
#define	DISPLAYED	0x56		/* user message displayed */

/* ERRDOS codes */

#define	ERRbadfunc	0x01		/* invalid function, EINVAL */
#define	ERRbadfile	0x02		/* file not found, ENOENT */
#define	ERRbadpath	0x03		/* directory invalid, ENOENT */
#define	ERRnofids	0x04		/* out of file descripters, EMFILE */
#define	ERRnoaccess	0x05		/* access denied, EPERM */
#define	ERRbadfid	0x06		/* invalid FID, EBADF */
#define	ERRbadmcb	0x07		/* memory control blocks destroyed */
#define	ERRnomem	0x08		/* out of server memory, ENOMEM */
#define	ERRbadmem	0x09		/* invalid memory block address, EFAULT */
#define	ERRbadenv	0x0A		/* invalid environment */
#define	ERRbadformat	0x0B		/* invalid format */
#define	ERRbadaccess	0x0C		/* invalid open mode */
#define	ERRbaddata	0x0D		/* invalid data, E2BIG */
#define	ERR		0x0E		/* reserved */
#define	ERRbaddrive	0x0F		/* invalid drive */
#define	ERRremcd	0x10		/* delete dir request on current dir */
#define	ERRdiffdevice	0x11		/* not same device, EXDEV */
#define	ERRnofiles	0x12		/* file search cmd failed */
#define	ERRbadshare	0x15		/* share mode conflict */
#define	ERRlock		0x16		/* lock request conflict */
#define	ERRfilexists	0x50		/* file exists, EEXIST */

/* ERRSRV codes */

#define	ERRerror	0x01		/* non-specific error */
#define	ERRbadpw	0x02		/* bad name/passwd pair */
#define	ERRbadtype	0x03		/* reserved */
#define	ERRaccess	0x04		/* access rights denied */
#define	ERRinvnid	0x05		/* TID invalid */
#define	ERRinvnetname	0x06		/* invalid net name */
#define	ERRinvdevice	0x07		/* invalid device */
#define	ERRqfull	0x31		/* printq full, on open */
#define	ERRqtoobig	0x32		/* printq full, no space */
#define	ERRqeof		0x33		/* EOF on printq dump */
#define	ERRinvpfid	0x34		/* invalid print file FID */
#define	ERRpaused	0x51		/* server is paused */
#define	ERRmsgoff	0x52		/* not receiving messages */
#define	ERRnoroom	0x53		/* no room to buffer message */
#define	ERRrmuns	0x57		/* too many remote user names */
#define	ERRnosupport  0xFFFF		/* function not supported */

/* ERRHRD codes */

#define	ERRnowrite	0x13		/* read-only media, EROFS */
#define	ERRbadunit	0x14		/* unknown unit, ENODEV */
#define	ERRnotready	0x15		/* drive not ready */
#define	ERRbadcmd	0x16		/* invalid disk drive */
#define	ERRdata		0x17		/* data error(CRC), EIO */
#define	ERRbadreq	0x18		/* bad request structure length */
#define	ERRseek		0x19		/* seek error */
#define	ERRbadmedia	0x1A		/* unknown media type */
#define	ERRbadsector	0x1B		/* sector not found */
#define	ERRnopaper	0x1C		/* printer out of paper */
#define	ERRwrite	0x1D		/* write fault */
#define	ERRread		0x1E		/* read fault */
#define	ERRgeneral	0x1F		/* general failure */
#define	ERRbadshar	0x20		/* compat open conflict */
